package fr.yobreuil.allomovies.data.persistance

import android.app.Application
import androidx.room.Database
import androidx.room.Room
import androidx.room.RoomDatabase
import fr.yobreuil.allomovies.data.Genre
import fr.yobreuil.allomovies.data.Movie

private const val ALLO_MOVIES_DB_FILENAME = "allomovies.db"

@Database(entities = [Genre::class, Movie::class], version = 1, exportSchema = false)
abstract class AlloMoviesDatabase : RoomDatabase() {
    abstract fun genreDao(): GenreDao

    companion object {
        private lateinit var application: Application

        @Volatile
        private var INSTANCE: AlloMoviesDatabase? = null

        /*fun getInstance(): AlloMoviesDatabase {
            if (::application.isInitialized) {
                if (INSTANCE == null) {
                    synchronized(this) {
                        if (INSTANCE == null) {
                            INSTANCE = Room.databaseBuilder(
                                application.applicationContext,
                                AlloMoviesDatabase::class.java,
                                ALLO_MOVIES_DB_FILENAME
                            ).build()

                            INSTANCE?.genreDao()
                        }
                    }
                }
                return INSTANCE!!
            }
        }*/
    }
}